﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using SAMLAuthDemo.EventCollector;

namespace SAMLAuthDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ShowECQuery();

        }


        private void ShowECQuery()
        {
            eventTableView.Enabled = false;
            eventTableView.ForeColor = Color.Gray;

            try
            {

                GenericResult result = Adapter.DoUncorrelatedECQuery("(severity='ERROR')");

                DataSet dsForDGV = new DataSet();
                BindingSource bs = new BindingSource();

                DataTable dataTable1 = ConvertResultToDataTable(result);
                dsForDGV.Tables.Clear();
                dsForDGV.Tables.Add(dataTable1);

                bs.DataSource = dsForDGV;
                bs.DataMember = dsForDGV.Tables[0].TableName;

                eventTableView.DataSource = bs;
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, "Error getting Audit Trail: " + ex.Message, "Error");
            }

            eventTableView.Enabled = true;
            eventTableView.ForeColor = Color.Black;
        }

        private DataTable ConvertResultToDataTable(GenericResult result)
        {
            DataTable dataTable1 = new DataTable("MyTable");
            dataTable1.Columns.Add(new DataColumn("Creation Time"));
            dataTable1.Columns.Add(new DataColumn("Severity"));
            dataTable1.Columns.Add(new DataColumn("Message"));


            int i = 0;
            if (result.resultEntry != null)
            {
                foreach (ResultEntry entry in result.resultEntry)
                {
                    dataTable1.Rows.Add(entry.id);
                    dataTable1.Rows[i][0] = GetAttributeFromEntry(entry, "creationTime");
                    dataTable1.Rows[i][1] = GetAttributeFromEntry(entry, "severity");
                    dataTable1.Rows[i][2] = GetAttributeFromEntry(entry, "message");
                    i++;
                }

            }

            return dataTable1;



        }

        private object GetAttributeFromEntry(ResultEntry entry, string attributeName)
        {
            foreach (BaseEntryAttribute attr in entry.attribute)
            {
                if (attr.attributeName.Equals(attributeName))
                {
                    switch (attr.type)
                    {
                        case AttributeType.BIGDECIMAL: return ((BigDecimalEntryAttribute)attr).value;
                        case AttributeType.BOOLEAN: return ((BooleanEntryAttribute)attr).value;
                        case AttributeType.DATE: return ((DateEntryAttribute)attr).value;
                        case AttributeType.DOUBLE: return ((DoubleEntryAttribute)attr).value;
                        case AttributeType.INT: return ((IntegerEntryAttribute)attr).value;
                        case AttributeType.LONG: return ((LongEntryAttribute)attr).value;
                        case AttributeType.STRING: return ((StringEntryAttribute)attr).value;
                        default: return "unknown";
                    }
                }
            }
            return "Unknown attribute";
        }
    }
}
