﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Security;
using System.ServiceModel.Security.Tokens;
using System.Text;

namespace SamlTools
{
    public class SamlBinding : Binding
    {
        HttpTransportBindingElement transBE = new HttpTransportBindingElement();

        TextMessageEncodingBindingElement encodingBE = new TextMessageEncodingBindingElement(MessageVersion.Soap11, Encoding.UTF8);

        public override BindingElementCollection CreateBindingElements()
        {
            transBE.MaxReceivedMessageSize = int.MaxValue;

            SecurityBindingElement securityBindingElement = SecurityBindingElement.CreateMutualCertificateBindingElement(
               MessageSecurityVersion.WSSecurity10WSTrustFebruary2005WSSecureConversationFebruary2005WSSecurityPolicy11BasicSecurityProfile10);

            AsymmetricSecurityBindingElement messageSec = (AsymmetricSecurityBindingElement)securityBindingElement;

            messageSec.MessageSecurityVersion = MessageSecurityVersion.WSSecurity10WSTrustFebruary2005WSSecureConversationFebruary2005WSSecurityPolicy11BasicSecurityProfile10;// WSSecurity11WSTrust13WSSecureConversation13WSSecurityPolicy12;//WSSecurity10WSTrustFebruary2005WSSecureConversationFebruary2005WSSecurityPolicy11BasicSecurityProfile10;

            messageSec.SetKeyDerivation(false);

            messageSec.IncludeTimestamp = false;

            messageSec.AllowInsecureTransport = true;
            messageSec.EnableUnsecuredResponse = true;

            IssuedSecurityTokenParameters issuedTokenParam = new IssuedSecurityTokenParameters("http://docs.oasis-open.org/wss/oasis-wss-saml-token-profile-1.1#SAMLV1.1");
            issuedTokenParam.KeyType = System.IdentityModel.Tokens.SecurityKeyType.AsymmetricKey;
            issuedTokenParam.DefaultMessageSecurityVersion = MessageSecurityVersion.WSSecurity10WSTrustFebruary2005WSSecureConversationFebruary2005WSSecurityPolicy11BasicSecurityProfile10;

            issuedTokenParam.UseStrTransform = false;

            messageSec.EndpointSupportingTokenParameters.Signed.Add(issuedTokenParam);

            BindingElementCollection beCol = new BindingElementCollection();
            beCol.Add(encodingBE);
            beCol.Add(messageSec);
            beCol.Add(transBE);

            return beCol;


        }

        public override string Scheme
        {
            get { return transBE.Scheme; }
        }

    }
}
